;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; http://CPCrulez.2ya.com
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

            org     &1000

            ld      hl, &0C000
            ld      de, &4000
            ld      bc, &4000
            ldir

            ld      de, &0C8
            ld      hl, &1B8
            call    &0BBCF           ; GRA WIN WIDTH
            ld      de, &50
            ld      hl, &140
            call    &0BBD2           ; GRA WIN HEIGHT
            ld      de, &140
            ld      hl, &0C8
            call    &0BBC9           ; GRA SET ORIGIN
            ld      a, &1
            ld      (byte_2105), a

loc_2033:   ld      hl, byte_2106
            ld      (word_20FF), hl
            ld      hl, byte_2466
            ld      (word_2101), hl
            xor     a
            ld      (byte_2103), a
            ld      (byte_2104), a

loc_2046:   call    &0BBDB           ; GRA CLEAR WINDOW

loc_2049:   call    sub_2091
            call    sub_20B1
            ld      a, (byte_2103)
            inc     a
            ld      (byte_2103), a
            cp      &0C
            jp      nz, loc_2049
            xor      a
            ld      (byte_2103), a

;;;            call      &0BD19

            ld      a, (byte_2105)
            cp      &0
            jp      z, loc_20E8
            cp      &1
            jp      z, loc_20D1

loc_206F:   ld      a, (byte_2104)
            inc     a
            ld      (byte_2104), a
            cp      &12
            jp      nz, loc_2046
            ld      a, &2F
            call    &0BB1E           ; PRESS "ESC" ?
            jp      z, loc_2033
            ld      a, &0C0
            call    &0BC08           ; SCR SET BASE
            ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

sub_2091:   ld      ix, (word_20FF)
            ld      d, (ix+&0)
            inc     ix
            ld      e, (ix+&0)
            inc     ix
            ld      h, (ix+&0)
            inc     ix
            ld      l, (ix+&0)
            inc     ix
            ld      (word_20FF), ix
            call    &0BBC0           ; GRA MOVE ABSOLUTE
            ret

sub_20B1:   ld      ix, (word_2101)
            ld      d, (ix+&0)
            inc     ix
            ld      e, (ix+&0)
            inc     ix
            ld      h, (ix+&0)
            inc     ix
            ld      l, (ix+&0)
            inc     ix
            ld      (word_2101), ix
            call    &0BBF6           ; GRA LINE ABSOLUTE
            ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

loc_20D1:   ld      a, &0C0
            call    &0BC08           ; SCR SET BASE
            ld      bc, &0BC0C
            out     (c), c
            ld      bc, &0BD10
            out     (c), c
            ld      a, &0
            ld      (byte_2105), a
            jp      loc_206F

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

loc_20E8:   ld      a, &40
            call    &0BC08
            ld      bc, &0BC0C
            out     (c), c
            ld      bc, &0BD30
            out     (c), c
            ld      a, &1
            ld      (byte_2105), a
            jp      loc_206F

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

word_20FF:      dw   &0
word_2101:      dw   &0
byte_2103:      db   &0
byte_2104:      db   &0
byte_2105:      db   &0
byte_2106:      read "data1.inc"
byte_2466:      read "data2.inc"